# Загрузка sql-дампа базы данных
Пакет DBAL содержит базовые средства для загрузки sql-дампов базы данных. В настоящее время поддерживается загрузка дампов для MySql, PostgreSQL, Oracle и SQLite.

Для загрузки дампа используется класс **lmbDbDump**, который в конструкторt принимает путь до файла с дампом и объект подключения к базе данных. Если объект подключения не указан - будет использоваться подключение по-умолчанию. lmbDbDump делегирует загрузку дампа конкретному загрузчику, который определяется на основе текущего соединения с БД.

Для выполнения загрузки используется метод **load()**, а для очистки таблиц, затронутых в рельтате загрузки дампа — **clean()**:

    require_once('limb/dbal/src/lmbDbDump.class.php');
 
    $type = lmbToolkit :: instance()->getDefaultDbConnection()->getType();
    $dump = new lmbDbDump(dirname(__FILE__) . '/.fixture/init_tests.' . $type);
    $dump->load();
 
    ...
 
    $dump->clean();

Реальные примеры использования lmbDbDump можно посмотреть в тестах на такие пакеты Limb3, как ACTIVE_RECORD и TREE (файлы .setup.php и .teardown.php)
